#version 430
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 uv;
layout (location = 3) in mat4 instanceMatrix;

uniform mat4 projectionView;
out vec2 fragmentUV;
out vec4 vertexColor;


void main()
{
	fragmentUV = uv;
    gl_Position = projectionView *instanceMatrix * vec4(position,1.0f);
	
	float distToCamera = max(0.0, length(gl_Position)-10.0f);
	float ratio = distToCamera / 5.0f;
	vertexColor = vec4(0.92f, 0.90f, 1.0f,1.0f);
	vertexColor.r = min(ratio, 1);
	vertexColor.g = gl_InstanceID;
}  