#version 430 core

in vec2 textureCoords;
uniform vec2 size;    
uniform float blurFactor; 
uniform float brightness; 
uniform vec2 origin;  

uniform sampler2D texture; 
out vec4 out_Colour;

void main(void)
{
  vec2 texCoord = textureCoords;
  vec4 SumColor = vec4(0.0f, 0.0f, 0.0f, 0.0f);
  texCoord += size * 0.5f - origin;

  for (int i = 0; i < 12; i++) 
  {
    float scale = 1.0f - blurFactor * (float(i) / 11.0f);
    SumColor += texture2D(texture, texCoord * scale + origin);
  }

  out_Colour = SumColor / 12.0f * brightness;
}