#version 430 core

in vec3 fragmentPosition;
in vec3 fragmentNormal;
in vec4 ShadowCoord;
in vec2 fragmentUV;
in mediump vec4 vertexColor;

layout(location = 0) out vec4 fragColor;
uniform vec3 cameraPosition;
uniform sampler2D texHigh;
uniform sampler2D texLow;
uniform int fog;
uniform int black;
uniform vec4 skyColor;
uniform vec3 sunPosition;
void main()
{
if(black==1){
fragColor=vec4(0.0f);
}else{
	// ambient light
	float lightMult=0.45;
	vec3 lightDir=normalize(sunPosition-fragmentPosition);
	float diff = + max(dot(normalize(fragmentNormal), lightDir), 0.0);
	lightMult = lightMult + diff;

	// set fragment height to 0 when height is less than 0, to avoid errors with negative values.
	float heightValue = fragmentPosition.y<0.0f?0.0f:fragmentPosition.y;

	// this is a basic color which is interpolated by the height of the terrain
	vec3 heightColor = vec3(0.3+0.4*(heightValue/1.8),0.25+0.3*(heightValue/2),0.3*(heightValue/1.5));
	
	vec4 textureHigh = texture(texHigh, fragmentUV).rgba;
	vec4 textureLow = texture(texLow, fragmentUV).rgba;

	// interpolation between the high and low texture
	vec4 combinedTextureColor = vec4(mix(textureLow.rgba,textureHigh.rgba,heightValue/2)); 
	
	// interpolation between texture color and height color
	vec4 finalColor =  lightMult* vec4(mix(vec4(heightColor.rgb,1.0f),combinedTextureColor.rgba,0.8)); 
	
	// fog interpolation if enabled
	if(fog==1){
	fragColor = mix(finalColor.rgba,skyColor.rgba,vertexColor.r);
	fragColor.a=1.0f;}
	else{fragColor =  finalColor;}
	}
}