#version 430


in vec3 position;
//in vec3 normal;

uniform vec3 cameraPosition;
uniform mat4 MVP;
uniform mat4 model;
uniform vec4 skyColour;
uniform vec3 sunPosition;
const float tiling = 1.0f;

out vec4 clipSpace;
out vec2 textureCoords;
out vec4 vertexColor;
out vec3 toCameraVector;
out vec3 fromLightVector;
out vec3 camPos;
out vec3 vertPos;

void main() 
{
	vertPos=position;
	camPos=cameraPosition;
	vec4 worldPosition = model *  vec4(position.x, 0.0f, position.z, 1.0f);
	clipSpace =  MVP * vec4(position, 1.0f);
	gl_Position=clipSpace;

	float distToCamera = max(0.0f, length(gl_Position)-10.0f);
	float ratio = distToCamera / 5.0f;
	vertexColor = skyColour;
	vertexColor.r = min(ratio, 1.0f);

	textureCoords =  vec2(position.x/2.0f + 0.5f, position.z/2.0f + 0.5f)*tiling;
	toCameraVector = cameraPosition - worldPosition.xyz;
	fromLightVector = worldPosition.xyz - sunPosition;

	
}